<template>
  <div>
    <v-layout>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="loadingSellerData"/>
      <v-flex>
        <v-card id="loginContentContainer"
          class="defaultCardBackground"
          v-if="showAddSellerForm">
          <v-progress-linear
            v-if="submitRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="lightSuccess"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
          <v-card-title>
            <h4 style="color:rgb(80, 130, 150)">
              Add Seller
            </h4>
          </v-card-title>
          <v-divider></v-divider>
          <form class="login"
            @submit.prevent="$v.$touch(); if($v.$error === false){addSeller()};">
            <div class="defaultInputContainer" v-bind:class="{ 'form-group--error': $v.firstName.$error }">
              <input id="firstName"
                class="inputDefault"
                type="text"
                v-model.trim="firstName"
                @input="$v.firstName.$touch()"
                v-on:input="$v.firstName.$touch"
                v-bind:class="{
                  error: $v.firstName.$error,
                  valid: $v.firstName.$dirty && !$v.firstName.$invalid
                }"/>
              <label for="firstName"
                class="defaultInputPlaceholder">
                First name
              </label>
              <span class="formErrorMessage"
                v-if="$v.firstName.$error && $v.firstName.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.firstName.$dirty && !$v.firstName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF3D00"
                v-if="$v.firstName.$error && $v.firstName.$dirty">
                cancel
              </v-icon>
            </div>
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.middleName.$error }">
              <input id="middleName"
                class="inputDefault"
                type="text"
                v-model.trim="middleName"
                @input="$v.middleName.$touch()"
                v-on:input="$v.middleName.$touch"
                v-bind:class="{
                  error: $v.middleName.$error,
                  valid: $v.middleName.$dirty && !$v.middleName.$invalid
                  }"/>
                <label for="middleName"
                  class="defaultInputPlaceholder">
                  Middle name
                </label>
                <span class="formErrorMessage"
                  v-if="$v.middleName.$error && $v.middleName.$dirty">
                  Required
                </span>
                <v-icon style="color:#5A5"
                  v-if="$v.middleName.$dirty && !$v.middleName.$invalid">
                  check_circle
                </v-icon>
                <v-icon style="color:#FF3D00"
                  v-if="$v.middleName.$error && $v.middleName.$dirty">
                  cancel
                </v-icon>
              </div>
              <div class="defaultInputContainer"
                v-bind:class="{ 'form-group--error': $v.lastName.$error }">
                <input id="lastName"
                  class="inputDefault"
                  type="text"
                  v-model.trim="lastName"
                  @input="$v.lastName.$touch()"
                  v-on:input="$v.lastName.$touch"
                  v-bind:class="{
                    error: $v.lastName.$error,
                    valid: $v.lastName.$dirty && !$v.lastName.$invalid
                    }"/>
                <label for="lastName"
                  class="defaultInputPlaceholder">
                  Last name
                </label>
                <span class="formErrorMessage"
                  v-if="$v.lastName.$error && $v.lastName.$dirty">
                  Required
                </span>
                <v-icon style="color:#5A5"
                  v-if="$v.lastName.$dirty && !$v.lastName.$invalid">
                    check_circle
                  </v-icon>
                <v-icon style="color:#FF3D00"
                  v-if="$v.lastName.$error && $v.lastName.$dirty">
                  cancel
                </v-icon>
              </div>
              <div class="defaultInputContainer"
                style="margin-top:0px;" v-bind:class="{ 'form-group--error': $v.sellerShopName.$error }">
                <span style="position: absolute;top: 30px;">
                  Store
                </span>
                <v-select
                  :items="storeNameList"
                  v-model="sellerShopName"
                  label="Select"
                  single-line
                  style="width:75%;margin-left:90px;height:50px;">
                </v-select>
                <span class="formErrorMessage"
                  v-if="$v.sellerShopName.$error && $v.sellerShopName.$dirty"
                  style="bottom:0px;">
                  Required
                </span>
                <v-icon style="color:#5A5;position: absolute;top: 30px;right: 7%;"
                  v-if="$v.sellerShopName.$dirty && !$v.sellerShopName.$invalid">
                  check_circle
                </v-icon>
                <v-icon style="color:#FF3D00;position: absolute;top: 30px;right: 7%;"
                  v-if="$v.sellerShopName.$error && $v.sellerShopName.$dirty">
                  cancel
                </v-icon>
              </div>
              <br/>
              <v-btn  block
                depressed
                dark
                color="darkSecondary"
                type="submit"
                style="width:90%;margin-left:5%;">
                ADD SELLER
              </v-btn>
              <br/><br/>
            </form>
        </v-card>
      </v-flex>
    </v-layout>
  </div>
</template>
<script scoped>
import { required } from 'vuelidate/lib/validators'
import axios from 'axios'
import DefaultSpinnerComponent from './../common/spinner.vue'
export default {
  name: 'AddSellerComponent',
  data: () => ({
    firstName: undefined,
    middleName: undefined,
    lastName: undefined,
    sellerShopName: undefined,
    name: '',
    text: '',
    submitRequested: false,
    storeNameList: [],
    showAddSellerForm: false,
    loadingSellerData: false,
    loadingMessage: 'Loading ...'
  }),
  methods: {
    addSeller () {
      if (this.firstName && this.middleName && this.lastName) {
        this.submitRequested = true
        axios.post('seller', {
          firstName: this.firstName,
          middleName: this.middleName,
          lastName: this.lastName,
          sellerShopName: this.sellerShopName
        }).then(response => {
          setTimeout(() => {
            this.submitRequested = false
            this.$router.push('/home/seller_view/' + this.firstName)
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', this.firstName + ' seller is succefully registered')
            this.$store.commit('UPDATE_ALL_SELLERS_LIST')
          }, 2000)
        })
          .catch(error => {
            this.submitRequested = false
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Seller registration error: ' + error)
          })
      }
    }
  },
  components: {
    DefaultSpinnerComponent
  },
  created () {
    this.loadingSellerData = true
    axios.get('store')
      .then(response => {
        setTimeout(() => {
          this.storeNameList = response.data
          this.loadingSellerData = false
          this.showAddSellerForm = true
        }, 2000)
      })
      .catch(error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error on getting all store names data: ' + error)
      })
  },
  validations: {
    firstName: {
      required
    },
    middleName: {
      required
    },
    lastName: {
      required
    },
    sellerShopName: {
      required
    }
  }
}
</script>
<style>
.error {
  border: 1px solid #FF3D00 !important;
  background: #ffffff !important;
}
.error:focus {
  outline-color: #F99;
}
.valid {
  border:1px solid #43A047 !important;
}
.valid:focus {
  outline-color: #43A047;
}
.formErrorMessage{
  color: #FF3D00;
  font-size: 14px;
  font-family: Roboto;
  position: absolute;
  left: 10px;
  bottom: -10px;
}

.login{
  padding-top: 1px;
}
#loginContentContainer{
  width: 50%;
  display: block;
  margin: 0 auto;
}
.loginContainer{
  background: #eeeeee !important;
  margin-top: 10vh;
}
.loginText{
  background: #F5F5F5;
  border: 1px solid #4D4D4D;
  border-radius: 4px;
  padding: 12px;
}
.ellaText{
  color: #a53a00;
}
@media only screen and (max-width: 1150px){
  #loginContentContainer{
    width: 50% !important;
  }
}
@media only screen and (max-width: 800px){
  #loginContentContainer{
    width: 70% !important;
  }
}
@media only screen and (max-width: 550px){
  #loginContentContainer{
    width: 80% !important;
  }
}
@media only screen and (max-width: 480px){
  #loginContentContainer{
    width: 96% !important;
  }
}
</style>
